import { Switch } from '../../../components/switch';
import { Player } from '../../../player';
import { DomNode } from '../../../utils/domNode';
import { IControllerEle } from '..';
export interface ISettingItemOption<T = any> {
    html?: string;
    selectedText?: string;
    value?: T;
}
export interface ISettingItem<T = any> {
    id?: any;
    html?: string;
    type?: 'switch' | 'select';
    checked?: boolean;
    options?: ISettingItemOption<T>[];
    value?: T;
    init?: (player: Player, item: ISettingItem) => void;
    change?: (value: T, player: Player, item: ISettingItem) => void;
    _switch?: Switch;
    _selectedEl?: HTMLElement;
    _optionEls?: HTMLElement[];
    _optionEl?: HTMLElement;
    [key: string]: any;
}
declare class Settings extends DomNode implements IControllerEle {
    readonly id = "settings";
    private player;
    private popoverTimer;
    private items;
    private popover;
    private stuffing;
    private homeEl;
    private currentOptionEl;
    init(player: Player): void;
    private renderHome;
    private renderOptions;
    private onItemClick;
    private onOptionClick;
    private showHomePage;
    private showOptionPage;
    show: () => void;
    tryHide(): void;
    hide: () => void;
    cleatTimeout: () => void;
    hideById: (id: string) => void;
}
export declare const settingControllerEle: () => Settings;
export {};
