import { Player } from '../../player';
import { DomNode } from '../../utils/domNode';
import { Tooltip } from '../../components/tooltip';
import { Dispose } from '../../utils/dispose';
import { IController } from '../../types';
import { ControllerEle } from './eles';
export interface IControllerEle extends Partial<Dispose> {
    el: HTMLElement;
    id?: any;
    tip?: string;
    mounted?: boolean;
    init?: (player: Player, tooltip: Tooltip) => void;
    [key: string]: any;
}
export declare class Controller extends DomNode {
    private player;
    private readonly gradientBottom;
    private showTimer;
    private controllerEles;
    constructor(player: Player, container: HTMLElement);
    show: () => void;
    hide: () => void;
    showThenFade: () => void;
    tryHide: () => void;
    updateEles(eles: Parameters<ControllerEle['update']>[0], key: keyof IController): void;
}
