var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { DomNode } from '../../utils/domNode';
import { createEle, removeClass, addClass } from '../../utils/dom';
import { addDispose, addDisposeListener } from '../../utils/dispose';
import { EVENT, TIME } from '../../constants';
import { ControllerEle } from './eles';
var classHide = 'controller_hide';
var classGradientBottomHide = 'controller_gradient_bottom_hide';
var Controller = /** @class */ (function (_super) {
    __extends(Controller, _super);
    function Controller(player, container) {
        var _this = _super.call(this, container, 'div.controller') || this;
        _this.player = player;
        _this.show = function () {
            removeClass(_this.el, classHide);
            removeClass(_this.gradientBottom, classGradientBottomHide);
            _this.player.el.style.cursor = '';
            _this.player.emit(EVENT.CONTROLLER_SHOW);
        };
        _this.hide = function () {
            addClass(_this.el, classHide);
            addClass(_this.gradientBottom, classGradientBottomHide);
            _this.player.el.style.cursor = 'none';
            _this.player.emit(EVENT.CONTROLLER_HIDE);
        };
        _this.showThenFade = function () {
            _this.show();
            clearTimeout(_this.showTimer);
            _this.showTimer = setTimeout(_this.tryHide, TIME.CONTROLLER_BAR_HIDE);
        };
        _this.tryHide = function () {
            if (_this.player.video.played.length && !_this.player.paused) {
                _this.hide();
            }
        };
        _this.gradientBottom = container.appendChild(createEle('div.controller_gradient_bottom'));
        _this.controllerEles = {
            progress: addDispose(_this, new ControllerEle(player, _this.el, player.options.controller.progress)),
            eles: addDispose(_this, new ControllerEle(player, _this.el, player.options.controller.eles)),
        };
        addDispose(_this, player.on(EVENT.PAUSE, function () {
            _this.show();
        }));
        addDispose(_this, player.on(EVENT.PLAY, function () {
            _this.showThenFade();
        }));
        addDisposeListener(_this, player.el, 'mousemove', _this.showThenFade);
        // The reason for not using `hide` is that we don't want to hide the controller when we pause.
        addDisposeListener(_this, player.el, 'mouseleave', _this.tryHide);
        // Here fo prevents the controller from being hidden because of the `autoplay` setting.
        _this.showThenFade();
        return _this;
    }
    Controller.prototype.updateEles = function (eles, key) {
        var curEle = this.controllerEles[key];
        if (!curEle)
            return;
        curEle.update(eles || []);
    };
    return Controller;
}(DomNode));
export { Controller };
//# sourceMappingURL=index.js.map