import { Player } from '../../player';
import { DomNode } from '../../utils/domNode';
export interface IMenuItem {
    id?: string;
    html?: string;
    hidden?: boolean;
    disabled?: boolean;
    checked?: boolean;
    init?: (player: Player, item: IMenuItem) => void;
    show?: (player: Player, item: IMenuItem) => void;
    click?: (player: Player, item: IMenuItem) => void;
}
export declare class Menu extends DomNode {
    private player;
    private items;
    private rect;
    private willShowDefault;
    constructor(container: HTMLElement, player: Player, items: IMenuItem[]);
    private getItemDoms;
    private renderItems;
    hide: () => void;
    show: () => void;
    get isActive(): boolean;
}
