var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { addDisposeListener } from '../../utils/dispose';
import { addClass, createEle, hide, removeAllChildNode, show } from '../../utils/dom';
import { DomNode } from '../../utils/domNode';
import { Rect } from '../../utils/rect';
var Menu = /** @class */ (function (_super) {
    __extends(Menu, _super);
    function Menu(container, player, items) {
        var _a;
        var _this = _super.call(this, container, '.menu') || this;
        _this.player = player;
        _this.items = items;
        _this.willShowDefault = false;
        _this.hide = function () {
            hide(_this.el);
        };
        _this.show = function () {
            show(_this.el);
        };
        _this.hide();
        _this.rect = new Rect(_this.el, player);
        (_a = _this.items) === null || _a === void 0 ? void 0 : _a.forEach(function (item) { var _a; return (_a = item.init) === null || _a === void 0 ? void 0 : _a.call(item, player, item); });
        addDisposeListener(_this, player.el, 'contextmenu', function (ev) {
            _this.hide();
            if (ev.target !== _this.player.video)
                return;
            if (!_this.willShowDefault) {
                ev.preventDefault();
                ev.stopPropagation();
                if (_this.renderItems()) {
                    _this.show();
                    _this.rect.update();
                    _this.player.rect.update();
                    var _a = _this.rect, width = _a.width, height = _a.height;
                    var _b = _this.player.rect, x = _b.x, y = _b.y;
                    var innerWidth_1 = window.innerWidth, innerHeight_1 = window.innerHeight;
                    var clientX = ev.clientX, clientY = ev.clientY;
                    var left = clientX - x;
                    var top_1 = clientY - y;
                    if (clientX + width > innerWidth_1)
                        left = innerWidth_1 - width;
                    if (clientY + height > innerHeight_1)
                        top_1 = innerHeight_1 - height;
                    _this.injectStyle({ left: left + "px", top: top_1 + "px" });
                }
            }
            if (player.options.showDefaultMenu) {
                _this.willShowDefault = !_this.willShowDefault;
            }
            else {
                _this.willShowDefault = false;
            }
        });
        addDisposeListener(_this, document, 'click', function () {
            _this.hide();
            _this.willShowDefault = false;
        });
        return _this;
    }
    Menu.prototype.getItemDoms = function () {
        var _this = this;
        return this.items
            .filter(function (item) { return item && !item.hidden; })
            .map(function (item) {
            var _a;
            var el = createEle('div.menu_item');
            (_a = item.show) === null || _a === void 0 ? void 0 : _a.call(item, _this.player, item);
            if (item.html)
                el.innerHTML = item.html;
            if (item.disabled)
                addClass(el, 'menu_item_disabled');
            if (item.checked)
                addClass(el, 'menu_item_checked');
            if (item.click) {
                el.addEventListener('click', function () { var _a; return (_a = item.click) === null || _a === void 0 ? void 0 : _a.call(item, _this.player, item); });
            }
            return el;
        });
    };
    Menu.prototype.renderItems = function () {
        var items = this.getItemDoms();
        if (!items.length)
            return false;
        removeAllChildNode(this.el);
        var frag = document.createDocumentFragment();
        items.forEach(function (dom) { return frag.appendChild(dom); });
        this.el.appendChild(frag);
        return true;
    };
    Object.defineProperty(Menu.prototype, "isActive", {
        get: function () {
            return this.el.style.display !== 'none';
        },
        enumerable: false,
        configurable: true
    });
    return Menu;
}(DomNode));
export { Menu };
//# sourceMappingURL=index.js.map