var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { EVENT } from '../../constants';
import { addDispose, addDisposeListener } from '../../utils/dispose';
import { addClass, createEle, hide, show } from '../../utils/dom';
import { DomNode } from '../../utils/domNode';
var Poster = /** @class */ (function (_super) {
    __extends(Poster, _super);
    function Poster(container, player) {
        var _this = _super.call(this, container, '.poster') || this;
        _this.player = player;
        _this.tryHide = function () {
            _this.hide();
        };
        var opts = player.options.posterOptions;
        _this.url = opts === null || opts === void 0 ? void 0 : opts.url;
        _this.hide();
        if (opts === null || opts === void 0 ? void 0 : opts.disabled)
            return _this;
        _this.show();
        if (_this.url) {
            var posterImg = createEle('img.poster_img');
            posterImg.src = _this.url;
            if (opts === null || opts === void 0 ? void 0 : opts.autoFill) {
                addClass(posterImg, 'poster_img_fill');
            }
            _this.el.appendChild(posterImg);
        }
        addDisposeListener(_this, _this.el, 'click', function () {
            if (player.loaded) {
                _this.hide();
            }
            else {
                player.loading.show();
            }
            player.play();
        });
        addDispose(_this, player.on(EVENT.CANPLAY, _this.tryHide));
        addDispose(_this, player.on(EVENT.LOADED_METADATA, _this.tryHide));
        return _this;
    }
    Object.defineProperty(Poster.prototype, "isActive", {
        get: function () {
            return this.el.style.display !== 'none';
        },
        enumerable: false,
        configurable: true
    });
    Poster.prototype.show = function () {
        show(this.el);
    };
    Poster.prototype.hide = function () {
        hide(this.el);
    };
    return Poster;
}(DomNode));
export { Poster };
//# sourceMappingURL=index.js.map