import { Dispose } from './dispose';
export declare function createEle<T extends HTMLElement>(tag?: string, attrs?: Record<string, any>, children?: string | Array<Node>, classPrefix?: string): T;
export declare function addChildren(container: HTMLElement, child?: string | Array<Node>): void;
export declare function getEle(el: HTMLElement | string | undefined | null): HTMLElement | null;
export declare function removeEle(el: Element): void;
export declare function removeAllChildNode(el: Element): void;
export declare function show(node: HTMLElement | SVGElement): void;
export declare function hide(node: HTMLElement | SVGElement): void;
export declare function addClass<T extends Element>(dom: T, cls?: string, prefix?: string): T;
export declare function removeClass<T extends Element>(dom: T, cls: string, prefix?: string): T;
export declare function containClass(dom: Element, cls: string, prefix?: string): boolean;
export declare function toggleClass(dom: Element, cls: string, force?: boolean, prefix?: string): boolean;
export declare function createSvg(cls?: string, d?: string, viewBox?: string): SVGSVGElement;
export declare function getEventPath(ev: Event): EventTarget[];
export declare class DomListener implements Dispose {
    private node;
    private type;
    private handler;
    private options?;
    constructor(node: EventTarget, type: string, handler: (e: any) => void, options?: boolean | AddEventListenerOptions | undefined);
    dispose(): void;
}
export declare function getElementSize(dom: HTMLElement): Pick<DOMRect, 'width' | 'height'>;
