import { dispose } from './dispose';
import { createEle, removeEle } from './dom';
import { isHTMLElement, isString } from './is';
var DomNode = /** @class */ (function () {
    function DomNode(container, tag, attrs, children, classPrefix) {
        if (tag && !isString(tag) && isHTMLElement(tag)) {
            this.el = tag;
        }
        else {
            this.el = createEle(tag, attrs, children, classPrefix);
        }
        if (container)
            container.appendChild(this.el);
    }
    DomNode.prototype.injectStyle = function (style) {
        Object.assign(this.el.style, style);
    };
    DomNode.prototype.dispose = function () {
        removeEle(this.el);
        dispose(this);
    };
    return DomNode;
}());
export { DomNode };
//# sourceMappingURL=domNode.js.map